package com.autentia.workflow.functions;

import java.util.Map;

import javax.annotation.Resource;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Service;

import com.autentia.workflow.Commissioning;
import com.autentia.workflow.CommissioningMgr;
import com.autentia.workflow.errors.MyAppException;
import com.opensymphony.module.propertyset.PropertySet;
import com.opensymphony.workflow.FunctionProvider;
import com.opensymphony.workflow.WorkflowException;
import com.opensymphony.workflow.spi.Step;

@Service
public class SetWorkflowState implements FunctionProvider {

	private static final Log log = LogFactory.getLog(SetWorkflowState.class);

	@Resource
	CommissioningMgr commissioningMgr;

	public void execute(final Map transientVars, final Map args, final PropertySet propertySet)
			throws WorkflowException {
		final Step step = (Step)transientVars.get("createdStep");
		Commissioning commissioning;
		try {
			commissioning = this.commissioningMgr.findByWorkflowId(step.getEntryId());
		} catch (final MyAppException e) {
			throw new WorkflowException(e);
		}
		if (commissioning == null) {
			throw new WorkflowException("no se ha encontrado ningn pedido asociado al workflow");
		}
		commissioning.setState(step.getStepId());

	}

}
